Loading...
Searching...
No Matches
file_meta_sink.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2012 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_BLOCKS_FILE_META_SINK_H
#define INCLUDED_BLOCKS_FILE_META_SINK_H
#include <gnuradio/blocks/api.h>
#include <gnuradio/sync_block.h>
namespace gr {
namespace blocks {
constexpr char METADATA_VERSION = 0;
constexpr size_t METADATA_HEADER_SIZE = 149;
enum gr_file_types {
GR_FILE_BYTE = 0,
GR_FILE_CHAR = 0,
GR_FILE_SHORT = 1,
GR_FILE_INT,
GR_FILE_LONG,
GR_FILE_LONG_LONG,
GR_FILE_FLOAT,
GR_FILE_DOUBLE,
};
/*!
* \brief Write stream to file with meta-data headers.
* \ingroup file_operators_blk
*
* \details
* These files represent data as binary information in between
* meta-data headers. The headers contain information about the
* type of data and properties of the data in the next segment of
* samples. The information includes:
*
* \li rx_rate (double): sample rate of data.
* \li rx_time (uint64_t, double): time stamp of first sample in segment.
* \li size (uint32_t): item size in bytes.
* \li type (::gr_file_types as int32_t): data type.
* \li cplx (bool): Is data complex?
* \li strt (uint64_t): Starting byte of data in this segment.
* \li bytes (uint64_t): Size in bytes of data in this segment.
*
* Tags can be sent to the file to update the information, which
* will create a new header. Headers are found by searching from
* the first header (at position 0 in the file) and reading where
* the data segment starts plus the data segment size. Following
* will either be a new header or EOF.
*/
class BLOCKS_API file_meta_sink : virtual public sync_block
{
public:
// gr::blocks::file_meta_sink::sptr
typedef std::shared_ptr<file_meta_sink> sptr;
/*!
* \brief Create a meta-data file sink.
*
* \param itemsize (size_t): Size of data type.
* \param filename (string): Name of file to write data to.
* \param samp_rate (double): Sample rate of data. If sample rate will be
* set by a tag, such as rx_tag from a UHD source, this is
* basically ignored.
* \param relative_rate (double): Rate chance from source of sample
* rate tag to sink.
* \param type (gr_file_types): Data type (int, float, etc.)
* \param complex (bool): If data stream is complex
* \param max_segment_size (size_t): Length of a single segment
* before the header is repeated (in items).
* \param extra_dict: a PMT dictionary of extra
* information.
* \param detached_header (bool): Set to true to store the header
* info in a separate file (named filename.hdr)
*/
static sptr make(size_t itemsize,
const std::string& filename,
double samp_rate = 1,
double relative_rate = 1,
gr_file_types type = GR_FILE_FLOAT,
bool complex = true,
size_t max_segment_size = 1000000,
pmt::pmt_t extra_dict = pmt::make_dict(),
bool detached_header = false);
virtual bool open(const std::string& filename) = 0;
virtual void close() = 0;
virtual void do_update() = 0;
virtual void set_unbuffered(bool unbuffered) = 0;
};
} /* namespace blocks */
} /* namespace gr */
#endif /* INCLUDED_BLOCKS_FILE_META_SINK_H */
gr::block::relative_rate
double relative_rate() const
return the approximate output rate / input rate
Definition gnuradio-runtime/include/gnuradio/block.h:305
gr::blocks::file_meta_sink
Write stream to file with meta-data headers.
Definition file_meta_sink.h:59
gr::blocks::file_meta_sink::make
static sptr make(size_t itemsize, const std::string &filename, double samp_rate=1, double relative_rate=1, gr_file_types type=GR_FILE_FLOAT, bool complex=true, size_t max_segment_size=1000000, pmt::pmt_t extra_dict=pmt::make_dict(), bool detached_header=false)
Create a meta-data file sink.
gr::blocks::file_meta_sink::close
virtual void close()=0
gr::blocks::file_meta_sink::set_unbuffered
virtual void set_unbuffered(bool unbuffered)=0
gr::blocks::file_meta_sink::do_update
virtual void do_update()=0
gr::blocks::file_meta_sink::sptr
std::shared_ptr< file_meta_sink > sptr
Definition file_meta_sink.h:62
gr::blocks::file_meta_sink::open
virtual bool open(const std::string &filename)=0
gr::sync_block::sync_block
sync_block(void)
Definition sync_block.h:28
api.h
BLOCKS_API
#define BLOCKS_API
Definition gr-blocks/include/gnuradio/blocks/api.h:18
gr::blocks
Definition abs_blk.h:20
gr::blocks::METADATA_VERSION
constexpr char METADATA_VERSION
Definition file_meta_sink.h:20
gr::blocks::gr_file_types
gr_file_types
Definition file_meta_sink.h:23
gr::blocks::GR_FILE_LONG
@ GR_FILE_LONG
Definition file_meta_sink.h:28
gr::blocks::GR_FILE_BYTE
@ GR_FILE_BYTE
Definition file_meta_sink.h:24
gr::blocks::GR_FILE_DOUBLE
@ GR_FILE_DOUBLE
Definition file_meta_sink.h:31
gr::blocks::GR_FILE_CHAR
@ GR_FILE_CHAR
Definition file_meta_sink.h:25
gr::blocks::GR_FILE_FLOAT
@ GR_FILE_FLOAT
Definition file_meta_sink.h:30
gr::blocks::GR_FILE_INT
@ GR_FILE_INT
Definition file_meta_sink.h:27
gr::blocks::GR_FILE_LONG_LONG
@ GR_FILE_LONG_LONG
Definition file_meta_sink.h:29
gr::blocks::GR_FILE_SHORT
@ GR_FILE_SHORT
Definition file_meta_sink.h:26
gr::blocks::METADATA_HEADER_SIZE
constexpr size_t METADATA_HEADER_SIZE
Definition file_meta_sink.h:21
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
pmt::pmt_t
std::shared_ptr< pmt_base > pmt_t
typedef for shared pointer (transparent reference counting).
Definition pmt.h:83
pmt::make_dict
PMT_API pmt_t make_dict()
Make an empty dictionary.
sync_block.h